#ifndef PLAYLISTDLG_H
#define PLAYLISTDLG_H

#include "Tools/MenuXP.h"
#include "Tools/ButtonXP.h"

class CSrchEdit : public CEdit
{
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	DECLARE_MESSAGE_MAP()
};

class CPLLB : public CListBox
{
	// Construction
public:
	CPLLB();
	~CPLLB();

	int prev;
	bool ShiftDown;
	bool CtrlDown;
	int posfrom;
	CDC memDC;
	CBitmap memBitmap;
	bool MemDCCreated;
	int width;
	int height;
	CMenu* menu;

	virtual void DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct);
	int GetFirstSelected(int from = 0);
	virtual void MeasureItem(LPMEASUREITEMSTRUCT lpMeasureItemStruct);

protected:
	afx_msg void OnKeyDown(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnKeyUp(UINT nChar, UINT nRepCnt, UINT nFlags);
	afx_msg void OnLButtonDblClk(UINT nFlags, CPoint point);
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnPaint();
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnRButtonUp(UINT nFlags, CPoint point);
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////
// CPlaylistDlg dialog

class CPlaylistDlg : public CDialog
{
	// Construction
public:
	CPlaylistDlg(UINT id, CWnd* pParent = NULL);   // standard constructor
	CPlaylistDlg* getInstance(UINT id);
	~CPlaylistDlg();

	HACCEL accel;
	CMenu* menu;
	int PlAtH;
	int PlAtW;
	int FrameH;
	int FrameW;
	int SrchH;
	int SrchW;
	int FNameT;
	int FNameL;
	int FNameH;
	int FNameW;
	bool CanResize;
	UINT TotalTime;
	CString PlayingFile;

	DWORD RemoveneThreadID;
	HANDLE RemoveneThreadHan;
	DWORD RemoveDuplicateEntriesThreadID;
	HANDLE RemoveDuplicateEntriesThreadHan;
	DWORD SortThreadID;
	HANDLE SortThreadHan;

	bool StopRemovene();
	bool StopRemoveDuplicateEntries();
	bool StopSort();
	void FillPlaylist();
	void PlaylistSave(bool saveall = true);
	void PlayTheFile(int fnum);
	void Remove(bool RAll = false, bool FromDisk = false);
	void SaveWindowPosAndDestroy();
	void ShowFileName();
	void ShowTimes();

	// Dialog Data
	enum
	{
		IDD = IDD_PLAYLIST
	};
	CEdit m_filename;
	CSrchEdit m_search;
	CPLLB m_playlistat;


	// Overrides
public:
	virtual BOOL PreTranslateMessage(MSG* pMsg);
protected:
	virtual void DoDataExchange(CDataExchange* pDX);  // DDX/DDV support

	// Implementation
protected:
	afx_msg void OnArrangeRemovene();
	afx_msg void OnArrangeRemoveDuplicateEntries();
	afx_msg void OnArrangeShuffle();
	afx_msg void OnArrangeSort();
	afx_msg void OnArrangeSortByFilename();
	afx_msg void OnChangeSearch();
	afx_msg void OnClose();
	virtual void OnCancel();
	afx_msg void OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnDropFiles(HDROP hDropInfo);
	afx_msg void OnEnterMenuLoop(BOOL bIsTrackPopupMenu);
	afx_msg void OnFileAddFile();
	afx_msg void OnFileAddFolder();
	afx_msg void OnFileEditTag();
	afx_msg void OnFileRemove();
	afx_msg void OnFileSaveInExtendedFormat();
	virtual BOOL OnInitDialog();
	afx_msg void OnKillFocusPlaylistAt();
	virtual void OnOK();
	afx_msg void OnPlaylistOpen();
	afx_msg void OnPlaylistSave();
	afx_msg void OnPopupSelectAll();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnTracksAddPlaylist();
	afx_msg void OnTracksFileManagementCopyTo();
	afx_msg void OnTracksFileManagementDelete();
	afx_msg void OnTracksFileManagementMoveTo();
	afx_msg void OnTracksRemoveAll();
	afx_msg void OnTracksRenameFiles();
	afx_msg void OnTracksReReadAllTags();
	afx_msg void OnTracksSelectionAddToExistentPlaylist();
	afx_msg void OnTracksSelectionCreateNewPlaylist();
	afx_msg void OnTrackMenu(UINT nID);
	DECLARE_MESSAGE_MAP()
		DECLARE_MENUXP()
};

#endif

extern CPlaylistDlg* PlaylistDlg;