#ifndef WAEMUWND_H
#define WAEMUWND_H
#include "wa_ipc.h"
#include "stdafx.h"

class CVidOut : public CDialog
{
public:
	CVidOut(UINT id, CWnd* pParent = NULL); 
	~CVidOut();
	PBITMAPINFO m_bmpinfo;
	HDC m_hdc;
	bool CanResize;
	unsigned char* donnees;
	int width;
	int height;
	void Draw();
protected:
	virtual void DoDataExchange(CDataExchange* pDX);  // DDX/DDV support
	virtual BOOL OnInitDialog();
	afx_msg void OnShowWindow(BOOL bShow, UINT nStatus);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnPaint();

	DECLARE_MESSAGE_MAP()
};

class CIVideoOutput : public IVideoOutput
{
public:
	CVidOut* vidOut;
	int width;
	int height;
	CIVideoOutput();
	~CIVideoOutput();
	void SetVidOut(CVidOut* pvidOut);
	int open(int w, int h, int vflip, double aspectratio, unsigned int fmt);
	void setcallback(LRESULT(*msgcallback)(void* token, HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam), void* token);
	void close();
	void draw(void* frame);
	void drawSubtitle(SubsItem* item);
	void showStatusMsg(const char* text);
	int get_latency();
	void notifyBufferState(int bufferstate);

	int extended(int param1, int param2, int param3); // Dispatchable, eat this!
};

/////////////////////////////////////////////////////////////////////////////
// CWAEmuWnd frame

class CWAEmuWnd : public CFrameWnd
{
	// Construction
public:
	CWAEmuWnd();
	~CWAEmuWnd();
	CWAEmuWnd* getInstance();
	CIVideoOutput* iVidOut;
	CVidOut* vidOut;

	// Overrides
	BOOL OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pData);
	virtual LRESULT WindowProc(UINT message, WPARAM wParam, LPARAM lParam);
	LRESULT IamWinamp(UINT message, WPARAM wParam, LPARAM lParam);
	BOOL DestroyWindow();
protected:
	afx_msg void OnMessageWINAMP_FILE_QUIT();
	afx_msg void OnMessageWINAMP_OPTIONS_PREFS();
	afx_msg void OnMessageWINAMP_OPTIONS_AOT();
	afx_msg void OnMessageWINAMP_FILE_REPEAT();
	afx_msg void OnMessageWINAMP_FILE_SHUFFLE();
	afx_msg void OnMessageWINAMP_HIGH_PRIORITY();
	afx_msg void OnMessageWINAMP_FILE_PLAY();
	afx_msg void OnMessageWINAMP_OPTIONS_EQ();
	afx_msg void OnMessageWINAMP_OPTIONS_ELAPSED();
	afx_msg void OnMessageWINAMP_OPTIONS_REMAINING();
	afx_msg void OnMessageWINAMP_OPTIONS_PLEDIT();
	afx_msg void OnMessageWINAMP_HELP_ABOUT();
	afx_msg void OnMessageWINAMP_MAINMENU();
	afx_msg void OnMessageWINAMP_BUTTON1();
	afx_msg void OnMessageWINAMP_BUTTON2();
	afx_msg void OnMessageWINAMP_BUTTON3();
	afx_msg void OnMessageWINAMP_BUTTON4();
	afx_msg void OnMessageWINAMP_BUTTON5();
	afx_msg void OnMessageWINAMP_BUTTON1_SHIFT();
	afx_msg void OnMessageWINAMP_BUTTON2_SHIFT();
	afx_msg void OnMessageWINAMP_BUTTON3_SHIFT();
	afx_msg void OnMessageWINAMP_BUTTON4_SHIFT();
	afx_msg void OnMessageWINAMP_BUTTON5_SHIFT();
	afx_msg void OnMessageWINAMP_BUTTON1_CTRL();
	afx_msg void OnMessageWINAMP_BUTTON2_CTRL();
	afx_msg void OnMessageWINAMP_BUTTON3_CTRL();
	afx_msg void OnMessageWINAMP_BUTTON4_CTRL();
	afx_msg void OnMessageWINAMP_BUTTON5_CTRL();
	afx_msg void OnMessageWINAMP_VOLUMEUP();
	afx_msg void OnMessageWINAMP_VOLUMEDOWN();
	afx_msg void OnMessageWINAMP_FFWD5S();
	afx_msg void OnMessageWINAMP_REW5S();
	afx_msg void OnMessageWINAMP_NEXT_WINDOW();
	afx_msg void OnMessageWINAMP_OPTIONS_WINDOWSHADE();
	afx_msg void OnMessageWINAMP_OPTIONS_DSIZE();
	afx_msg void OnMessageIDC_SORT_FILENAME();
	afx_msg void OnMessageIDC_SORT_FILETITLE();
	afx_msg void OnMessageIDC_SORT_ENTIREFILENAME();
	afx_msg void OnMessageIDC_SELECTALL();
	afx_msg void OnMessageIDC_SELECTNONE();
	afx_msg void OnMessageIDC_SELECTINV();
	afx_msg void OnMessageIDM_EQ_LOADPRE();
	afx_msg void OnMessageIDM_EQ_LOADMP3();
	afx_msg void OnMessageIDM_EQ_LOADDEFAULT();
	afx_msg void OnMessageIDM_EQ_SAVEPRE();
	afx_msg void OnMessageIDM_EQ_SAVEMP3();
	afx_msg void OnMessageIDM_EQ_SAVEDEFAULT();
	afx_msg void OnMessageIDM_EQ_DELPRE();
	afx_msg void OnMessageIDM_EQ_DELMP3();
	afx_msg void OnMessageIDC_PLAYLIST_PLAY();
	afx_msg void OnMessageWINAMP_FILE_LOC();
	afx_msg void OnMessageWINAMP_OPTIONS_EASYMOVE();
	afx_msg void OnMessageWINAMP_FILE_DIR();
	afx_msg void OnMessageWINAMP_EDIT_ID3();
	afx_msg void OnMessageWINAMP_TOGGLE_AUTOSCROLL();
	afx_msg void OnMessageWINAMP_VISSETUP();
	afx_msg void OnMessageWINAMP_PLGSETUP();
	afx_msg void OnMessageWINAMP_VISPLUGIN();
	afx_msg void OnMessageWINAMP_JUMP();
	afx_msg void OnMessageWINAMP_JUMPFILE();
	afx_msg void OnMessageWINAMP_JUMP10FWD();
	afx_msg void OnMessageWINAMP_JUMP10BACK();
	afx_msg void OnMessageWINAMP_PREVSONG();
	afx_msg void OnMessageWINAMP_OPTIONS_EXTRAHQ();
	afx_msg void OnMessageID_PE_NEW();
	afx_msg void OnMessageID_PE_OPEN();
	afx_msg void OnMessageID_PE_SAVE();
	afx_msg void OnMessageID_PE_SAVEAS();
	afx_msg void OnMessageID_PE_SELECTALL();
	afx_msg void OnMessageID_PE_INVERT();
	afx_msg void OnMessageID_PE_NONE();
	afx_msg void OnMessageID_PE_ID3();
	afx_msg void OnMessageID_PE_S_TITLE();
	afx_msg void OnMessageID_PE_S_FILENAME();
	afx_msg void OnMessageID_PE_S_PATH();
	afx_msg void OnMessageID_PE_S_RANDOM();
	afx_msg void OnMessageID_PE_S_REV();
	afx_msg void OnMessageID_PE_CLEAR();
	afx_msg void OnMessageID_PE_MOVEUP();
	afx_msg void OnMessageID_PE_MOVEDOWN();
	afx_msg void OnMessageWINAMP_SELSKIN();
	afx_msg void OnMessageWINAMP_VISCONF();
	afx_msg void OnMessageID_PE_NONEXIST();
	afx_msg void OnMessageID_PE_DELETEFROMDISK();
	afx_msg void OnMessageID_PE_CLOSE();
	afx_msg void OnMessageWINAMP_VIS_SETOSC();
	afx_msg void OnMessageWINAMP_VIS_SETANA();
	afx_msg void OnMessageWINAMP_VIS_SETOFF();
	afx_msg void OnMessageWINAMP_VIS_DOTSCOPE();
	afx_msg void OnMessageWINAMP_VIS_LINESCOPE();
	afx_msg void OnMessageWINAMP_VIS_SOLIDSCOPE();
	afx_msg void OnMessageWINAMP_VIS_NORMANA();
	afx_msg void OnMessageWINAMP_VIS_FIREANA();
	afx_msg void OnMessageWINAMP_VIS_LINEANA();
	afx_msg void OnMessageWINAMP_VIS_NORMVU();
	afx_msg void OnMessageWINAMP_VIS_SMOOTHVU();
	afx_msg void OnMessageWINAMP_VIS_FULLREF();
	afx_msg void OnMessageWINAMP_VIS_FULLREF2();
	afx_msg void OnMessageWINAMP_VIS_FULLREF3();
	afx_msg void OnMessageWINAMP_VIS_FULLREF4();
	afx_msg void OnMessageWINAMP_OPTIONS_TOGTIME();
	afx_msg void OnMessageEQ_ENABLE();
	afx_msg void OnMessageEQ_AUTO();
	afx_msg void OnMessageEQ_PRESETS();
	afx_msg void OnMessageWINAMP_VIS_FALLOFF0();
	afx_msg void OnMessageWINAMP_VIS_FALLOFF1();
	afx_msg void OnMessageWINAMP_VIS_FALLOFF2();
	afx_msg void OnMessageWINAMP_VIS_FALLOFF3();
	afx_msg void OnMessageWINAMP_VIS_FALLOFF4();
	afx_msg void OnMessageWINAMP_VIS_PEAKS();
	afx_msg void OnMessageID_LOAD_EQF();
	afx_msg void OnMessageID_SAVE_EQF();
	afx_msg void OnMessageID_PE_ENTRY();
	afx_msg void OnMessageID_PE_SCROLLUP();
	afx_msg void OnMessageID_PE_SCROLLDOWN();
	afx_msg void OnMessageWINAMP_MAIN_WINDOW();
	afx_msg void OnMessageWINAMP_VIS_PFALLOFF0();
	afx_msg void OnMessageWINAMP_VIS_PFALLOFF1();
	afx_msg void OnMessageWINAMP_VIS_PFALLOFF2();
	afx_msg void OnMessageWINAMP_VIS_PFALLOFF3();
	afx_msg void OnMessageWINAMP_VIS_PFALLOFF4();
	afx_msg void OnMessageID_PE_TOP();
	afx_msg void OnMessageID_PE_BOTTOM();
	afx_msg void OnMessageWINAMP_OPTIONS_WINDOWSHADE_PL();
	afx_msg void OnMessageEQ_INC1();
	afx_msg void OnMessageEQ_INC2();
	afx_msg void OnMessageEQ_INC3();
	afx_msg void OnMessageEQ_INC4();
	afx_msg void OnMessageEQ_INC5();
	afx_msg void OnMessageEQ_INC6();
	afx_msg void OnMessageEQ_INC7();
	afx_msg void OnMessageEQ_INC8();
	afx_msg void OnMessageEQ_INC9();
	afx_msg void OnMessageEQ_INC10();
	afx_msg void OnMessageEQ_INCPRE();
	afx_msg void OnMessageEQ_DECPRE();
	afx_msg void OnMessageEQ_DEC1();
	afx_msg void OnMessageEQ_DEC2();
	afx_msg void OnMessageEQ_DEC3();
	afx_msg void OnMessageEQ_DEC4();
	afx_msg void OnMessageEQ_DEC5();
	afx_msg void OnMessageEQ_DEC6();
	afx_msg void OnMessageEQ_DEC7();
	afx_msg void OnMessageEQ_DEC8();
	afx_msg void OnMessageEQ_DEC9();
	afx_msg void OnMessageEQ_DEC10();
	afx_msg void OnMessageID_PE_SCUP();
	afx_msg void OnMessageID_PE_SCDOWN();
	afx_msg void OnMessageWINAMP_REFRESHSKIN();
	afx_msg void OnMessageID_PE_PRINT();
	afx_msg void OnMessageID_PE_EXTINFO();
	afx_msg void OnMessageWINAMP_PLAYLIST_ADVANCE();
	afx_msg void OnMessageWINAMP_VIS_LIN();
	afx_msg void OnMessageWINAMP_VIS_BAR();
	afx_msg void OnMessageWINAMP_OPTIONS_MINIBROWSER();
	afx_msg void OnMessageMB_FWD();
	afx_msg void OnMessageMB_BACK();
	afx_msg void OnMessageMB_RELOAD();
	afx_msg void OnMessageMB_OPENMENU();
	afx_msg void OnMessageMB_OPENLOC();
	afx_msg void OnMessageWINAMP_NEW_INSTANCE();
	afx_msg void OnMessageMB_UPDATE();
	afx_msg void OnMessageWINAMP_OPTIONS_WINDOWSHADE_EQ();
	afx_msg void OnMessageEQ_PANLEFT();
	afx_msg void OnMessageEQ_PANRIGHT();
	afx_msg void OnMessageWINAMP_GETMORESKINS();
	afx_msg void OnMessageWINAMP_VIS_OPTIONS();
	afx_msg void OnMessageWINAMP_PE_SEARCH();
	afx_msg void OnMessageID_PE_BOOKMARK();
	afx_msg void OnMessageWINAMP_EDIT_BOOKMARKS();
	afx_msg void OnMessageWINAMP_MAKECURBOOKMARK();
	afx_msg void OnMessageID_MAIN_PLAY_BOOKMARK_NONE();
	afx_msg void OnMessageID_MAIN_PLAY_AUDIOCD();
	afx_msg void OnMessageID_MAIN_PLAY_AUDIOCD2();
	afx_msg void OnMessageID_MAIN_PLAY_AUDIOCD3();
	afx_msg void OnMessageID_MAIN_PLAY_AUDIOCD4();
	afx_msg void OnMessageWINAMP_OPTIONS_VIDEO();
	afx_msg void OnMessageID_VIDEOWND_ZOOMFULLSCREEN();
	afx_msg void OnMessageID_VIDEOWND_ZOOM100();
	afx_msg void OnMessageID_VIDEOWND_ZOOM200();
	afx_msg void OnMessageID_VIDEOWND_ZOOM50();
	afx_msg void OnMessageID_VIDEOWND_VIDEOOPTIONS();
	afx_msg void OnMessageWINAMP_MINIMIZE();
	afx_msg void OnMessageID_PE_FONTBIGGER();
	afx_msg void OnMessageID_PE_FONTSMALLER();
	afx_msg void OnMessageWINAMP_VIDEO_TOGGLE_FS();
	afx_msg void OnMessageWINAMP_VIDEO_TVBUTTON();
	afx_msg void OnMessageWINAMP_LIGHTNING_CLICK();
	afx_msg void OnMessageID_FILE_ADDTOLIBRARY();
	afx_msg void OnMessageID_HELP_HELPTOPICS();
	afx_msg void OnMessageID_HELP_GETTINGSTARTED();
	afx_msg void OnMessageID_HELP_WINAMPFORUMS();
	afx_msg void OnMessageID_PLAY_VOLUMEUP();
	afx_msg void OnMessageID_PLAY_VOLUMEDOWN();
	afx_msg void OnMessageID_PEFILE_OPENPLAYLISTFROMLIBRARY_NOPLAYLISTSINLIBRARY();
	afx_msg void OnMessageID_PEFILE_ADDFROMLIBRARY();
	afx_msg void OnMessageID_PEFILE_CLOSEPLAYLISTEDITOR();
	afx_msg void OnMessageID_PEPLAYLIST_PLAYLISTPREFERENCES();
	afx_msg void OnMessageID_MLFILE_NEWPLAYLIST();
	afx_msg void OnMessageID_MLFILE_LOADPLAYLIST();
	afx_msg void OnMessageID_MLFILE_SAVEPLAYLIST();
	afx_msg void OnMessageID_MLFILE_ADDMEDIATOLIBRARY();
	afx_msg void OnMessageID_MLFILE_CLOSEMEDIALIBRARY();
	afx_msg void OnMessageID_MLVIEW_NOWPLAYING();
	afx_msg void OnMessageID_MLVIEW_LOCALMEDIA_ALLMEDIA();
	afx_msg void OnMessageID_MLVIEW_LOCALMEDIA_AUDIO();
	afx_msg void OnMessageID_MLVIEW_LOCALMEDIA_VIDEO();
	afx_msg void OnMessageID_MLVIEW_PLAYLISTS_NOPLAYLISTINLIBRARY();
	afx_msg void OnMessageID_MLVIEW_INTERNETRADIO();
	afx_msg void OnMessageID_MLVIEW_INTERNETTV();
	afx_msg void OnMessageID_MLVIEW_LIBRARYPREFERENCES();
	afx_msg void OnMessageID_MLVIEW_DEVICES_NOAVAILABLEDEVICE();
	afx_msg void OnMessageID_MLFILE_IMPORTCURRENTPLAYLIST();
	afx_msg void OnMessageID_MLVIEW_MEDIA();
	afx_msg void OnMessageID_MLVIEW_PLAYLISTS();
	afx_msg void OnMessageID_MLVIEW_MEDIA_ALLMEDIA();
	afx_msg void OnMessageID_MLVIEW_DEVICES();
	afx_msg void OnMessageID_FILE_SHOWLIBRARY();
	afx_msg void OnMessageID_FILE_CLOSELIBRARY();
	afx_msg void OnMessageID_POST_PLAY_PLAYLIST();
	afx_msg void OnMessageID_VIS_NEXT();
	afx_msg void OnMessageID_VIS_PREV();
	afx_msg void OnMessageID_VIS_RANDOM();
	afx_msg void OnMessageID_MANAGEPLAYLISTS();
	afx_msg void OnMessageID_PREFS_SKIN_SWITCHTOSKIN();
	afx_msg void OnMessageID_PREFS_SKIN_DELETESKIN();
	afx_msg void OnMessageID_PREFS_SKIN_RENAMESKIN();
	afx_msg void OnMessageID_VIS_FS();
	afx_msg void OnMessageID_VIS_CFG();
	afx_msg void OnMessageID_VIS_MENU();
	afx_msg void OnMessageID_VIS_SET_FS_FLAG();
	afx_msg void OnMessageID_PE_SHOWPLAYING();
	afx_msg void OnMessageID_HELP_REGISTERWINAMPPRO();
	afx_msg void OnMessageID_PE_MANUAL_ADVANCE();
	afx_msg void OnMessageWA_SONG_5_STAR_RATING();
	afx_msg void OnMessageWA_SONG_4_STAR_RATING();
	afx_msg void OnMessageWA_SONG_3_STAR_RATING();
	afx_msg void OnMessageWA_SONG_2_STAR_RATING();
	afx_msg void OnMessageWA_SONG_1_STAR_RATING();
	afx_msg void OnMessageWA_SONG_NO_RATING();
	afx_msg void OnMessagePL_SONG_5_STAR_RATING();
	afx_msg void OnMessagePL_SONG_4_STAR_RATING();
	afx_msg void OnMessagePL_SONG_3_STAR_RATING();
	afx_msg void OnMessagePL_SONG_2_STAR_RATING();
	afx_msg void OnMessagePL_SONG_1_STAR_RATING();
	afx_msg void OnMessagePL_SONG_NO_RATING();
	afx_msg void OnMessageAUDIO_TRACK_ONE();
	afx_msg void OnMessageVIDEO_TRACK_ONE();
	// Implementation
protected:
	DECLARE_DYNCREATE(CWAEmuWnd)
	DECLARE_MESSAGE_MAP()
};

/////////////////////////////////////////////////////////////////////////////

#endif

extern CWAEmuWnd* WAEmuWnd;
