// MP3InfoDlg.cpp : implementation file
//

#include "../stdafx.h"
#include "../resource.h"   	// main symbols
#include "../wa_ipc.h"
#include "in_mpg123.h"
#include "TagInfo.h"
#include "MP3InfoDlg.h"
#include "../TagEditor.h"
#include "../MainHelper.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

extern CStringArray genres;
CMP3InfoDlg* MP3InfoDlg = NULL;

/////////////////////////////////////////////////////////////////////////////
// CMP3InfoDlg dialog


CMP3InfoDlg::CMP3InfoDlg(UINT id, CWnd* pParent /*=NULL*/) : CDialog(id, pParent)
{
	m_album = _T("");
	m_artist = _T("");
	m_comment = _T("");
	m_filename = _T("");
	m_genre = _T("");
	m_title = _T("");
	m_year = _T("");
	m_bitrate = _T("");
	m_freq = _T("");
	m_mode = _T("");
}

CMP3InfoDlg::~CMP3InfoDlg()
{
	MP3InfoDlg = NULL;
}

CMP3InfoDlg* CMP3InfoDlg::getInstance(UINT id, CWnd* pParent)
{
	if (MP3InfoDlg != NULL && MP3InfoDlg->m_hWnd == NULL)
	{
		delete MP3InfoDlg;
		MP3InfoDlg = NULL;
	}
	if (MP3InfoDlg == NULL)
	{
		MP3InfoDlg = new CMP3InfoDlg(id, pParent);
		MP3InfoDlg->Create(id, pParent);
	}
	else
		MP3InfoDlg->SetFocus();
	return MP3InfoDlg;
}

IMPLEMENT_MENUXP(CMP3InfoDlg, CDialog)

BEGIN_MESSAGE_MAP(CMP3InfoDlg, CDialog)
ON_BN_CLICKED(IDC_EDITTAG, OnEditTag)
ON_MENUXP_MESSAGES()
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMP3InfoDlg message handlers

void CMP3InfoDlg::DoDataExchange(CDataExchange* pDX)
{
	CMenuXP::SetXPLookNFeel(this, GetProfileInt(_T("Preferences"), _T("XPLookNFeel"), 0)==1);
	CDialog::DoDataExchange(pDX);
	DDX_Text(pDX, IDC_EDIT_ALBUM, m_album);
	DDX_Text(pDX, IDC_EDIT_ARTIST, m_artist);
	DDX_Text(pDX, IDC_EDIT_COMMENT, m_comment);
	DDX_Text(pDX, IDC_EDIT_FILENAME, m_filename);
	DDX_Text(pDX, IDC_EDIT_GENRE, m_genre);
	DDX_Text(pDX, IDC_EDIT_TITLE, m_title);
	DDX_Text(pDX, IDC_EDIT_YEAR, m_year);
	DDX_Text(pDX, IDC_EDIT_BITRATE, m_bitrate);
	DDX_Text(pDX, IDC_EDIT_FREQ, m_freq);
	DDX_Text(pDX, IDC_EDIT_MODE, m_mode);
	DDX_Control(pDX, IDC_EDITTAG, m_btn_EditTag);
}


void CMP3InfoDlg::ReadInfo()
{
	m_filename = info->FileName;

	CString mbuf = "";
	m_bitrate = mbuf.Left(mbuf.Find('@'));
	mbuf = mbuf.Mid(mbuf.Find('@') + 1);
	m_freq = mbuf.Left(mbuf.Find('@'));
	m_mode = mbuf.Mid(mbuf.Find('@') + 1);

	if (PrevFile == m_filename)
	{
		UpdateData(FALSE);
		return;
	}
	PrevFile = m_filename;

	m_album = info->Album;
	m_artist = info->Artist;
	m_comment = info->Comment;
	m_genre = info->Genre;
	m_title = info->Title;
	m_year = info->Year;

	UpdateData(false);
}

void CMP3InfoDlg::OnEditTag()
{
	CTagEditor TagEditor(IDD_TAGEDIT, this);

	TagEditor.m_album = info->Album;
	TagEditor.m_artist = info->Artist;
	TagEditor.m_comment = info->Comment;
	TagEditor.m_filename = info->FileName;
	TagEditor.m_title = info->Title;
	TagEditor.m_year = info->Year;
//	TagEditor.m_genre = info->Genre;

	if (TagEditor.DoModal() == IDOK)
	{
		PrevFile = "*";
		ReadInfo();
	}
}

BOOL CMP3InfoDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	m_Helper.translateWindowText(this, IDD_DIALOG_MP3INFO);
	m_Helper.translateDlgItemText(this, IDC_LFILENAME);
	m_Helper.translateDlgItemText(this, IDC_LBITRATE);
	m_Helper.translateDlgItemText(this, IDC_LKBPS);
	m_Helper.translateDlgItemText(this, IDC_LFREQ);
	m_Helper.translateDlgItemText(this, IDC_LHZ);
	m_Helper.translateDlgItemText(this, IDC_LMODE);
	m_Helper.translateDlgItemText(this, IDC_LTITLE);
	m_Helper.translateDlgItemText(this, IDC_LARTIST);
	m_Helper.translateDlgItemText(this, IDC_LALBUM);
	m_Helper.translateDlgItemText(this, IDC_LYEAR);
	m_Helper.translateDlgItemText(this, IDC_LCOMMENT);
	m_Helper.translateDlgItemText(this, IDC_LGENRE);
	m_Helper.translateDlgItemText(this, IDC_EDITTAG);

	PrevFile = "*";
	m_btn_EditTag.EnableWindow(FALSE);
	ReadInfo();

	return TRUE;  // return TRUE unless you set the focus to a control
	// EXCEPTION: OCX Property Pages should return FALSE
}
